A YANG Data Model for Tunnel Interface Types
RFC 8675
Mohamed Boucadair
Orange
Ian Farrer
Deutsche Telekom AG
Rajiv Asati
Cisco Systems, Inc.
2019-11
Softwire Working Group
softwire
Augment tunnel
tunnel management
tunnel provisioning
tunnel activation
tunnel automation
This document specifies the initial version of a YANG module "iana-tunnel-type", which contains a collection of IANA-maintained YANG identities used as interface types for tunnel interfaces. The module reflects the "tunnelType" registry maintained by IANA. The latest revision of this YANG module can be obtained from the IANA website.
Tunnel type values are not directly added to the Tunnel Interface Types YANG module; they must instead be added to the "tunnelType" IANA registry. Once a new tunnel type registration is made by IANA for a new tunneling scheme or even an existing one that is not already listed in the current registry (e.g., LISP, NSH), IANA will update the Tunnel Interface Types YANG module accordingly.
Some of the IETF-defined tunneling techniques are not listed in the current IANA registry. It is not the intent of this document to update the existing IANA registry with a comprehensive list of tunnel technologies. Registrants must follow the IETF registration procedure for interface types whenever a new tunnel type is needed.
Status of This Memo
This is an Internet Standards Track document.
This document is a product of the Internet Engineering Task Force (IETF). It represents the consensus of the IETF community. It has received public review and has been approved for publication by the Internet Engineering Steering Group (IESG). Further information on Internet Standards is available in Section 2 of RFC 7841.
Information about the current status of this document, any errata, and how to provide feedback on it may be obtained at https://www.rfc-editor.org/info/rfc8675.
Copyright Notice
Copyright (c) 2019 IETF Trust and the persons identified as the document authors. All rights reserved.
This document is subject to BCP 78 and the IETF Trust's Legal Provisions Relating to IETF Documents (https://trustee.ietf.org/license-info) in effect on the date of publication of this document. Please review these documents carefully, as they describe your rights and restrictions with respect to this document. Code Components extracted from this document must include Simplified BSD License text as described in Section 4.e of the Trust Legal Provisions and are provided without warranty as described in the Simplified BSD License.
Table of Contents
- 1. Introduction
- 2. IANA Tunnel Type YANG Module
- 3. Security Considerations
- 4. IANA Considerations
  - 4.1. YANG Module
  - 4.2. Updates to the IANA tunnelType Table
- 5. References
  - 5.1. Normative References
  - 5.2. Informative References
- Appendix A. Example Usage
- Acknowledgements
- Authors' Addresses
Introduction
This document specifies the initial version of the iana-tunnel-type YANG module containing a collection of IANA-maintained YANG identities identifying tunnel interface types. The module reflects IANA's tunnelType registry under the SMI Numbers registry [TUNNELTYPE-IANA-REGISTRY]. The latest revision of this module can be obtained from the IANA website.
Tunnel-specific extensions may be added to the Interface module [RFC8343] as a function of the tunnel type. An example of this is provided in Appendix A. It is not the intention of this document to define tunnel-specific extensions for every tunnel encapsulation technology; those are discussed in dedicated documents such as [RFC8676]. Likewise, it is out of the scope of this document to update the existing IANA tunnelType registry [TUNNELTYPE-IANA-REGISTRY] with a comprehensive list of tunnel technologies. Guidelines and registration procedures for interface types and sub-types are discussed in [IFTYPE-REG].
This document uses the common YANG types defined in [RFC6991] and adopts the Network Management Datastore Architecture (NMDA [RFC8342]).
The terminology for describing YANG modules is defined in [RFC7950]. The meanings of the symbols used in the tree diagram are defined in [RFC8340].
IANA Tunnel Type YANG Module
The iana-tunnel-type module imports the 'iana-if-type' module defined in [RFC7224].
The initial version of the module includes tunnel types defined in [RFC4087], [RFC7856], [RFC7870], and [RFC6346].

module iana-tunnel-type {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:iana-tunnel-type";
  prefix iana-tunnel-type;

  import iana-if-type {
    prefix ift;
    reference
      "RFC 7224: IANA Interface Type YANG Module";
  }

  organization
    "IANA";
  contact
    "Internet Assigned Numbers Authority

     Postal: ICANN
          12025 Waterfront Drive, Suite 300
          Los Angeles, CA  90094-2536
          United States of America
     Tel:    +1 310 301 5800
     <mailto:iana@iana.org>";
  description
    "This module contains a collection of YANG identities defined
     by IANA and used as interface types for tunnel interfaces.

     Copyright (c) 2019 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject
     to the license terms contained in, the Simplified BSD License
     set forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC 8675; see
     the RFC itself for full legal notices.";

  revision 2019-11-16 {
    description
      "Initial revision.";
    reference
      "RFC 8675: A YANG Data Model for Tunnel Interface Types";
  }

  identity other {
    base ift:tunnel;
    description
      "None of the following values.";
    reference
      "RFC 4087: IP Tunnel MIB";
  }

  identity direct {
    base ift:tunnel;
    description
      "No intermediate header.";
    reference
      "RFC 2003: IP Encapsulation within IP
       RFC 4213: Basic Transition Mechanisms for IPv6 Hosts
                 and Routers";
  }

  identity gre {
    base ift:tunnel;
    description
      "GRE encapsulation.";
    reference
      "RFC 1701: Generic Routing Encapsulation (GRE)
       RFC 1702: Generic Routing Encapsulation over IPv4 networks
       RFC 7676: IPv6 Support for Generic Routing Encapsulation
                 (GRE)";
  }

  identity minimal {
    base ift:tunnel;
    description
      "Minimal encapsulation.";
    reference
      "RFC 2004: Minimal Encapsulation within IP";
  }

  identity l2tp {
    base ift:tunnel;
    description
      "L2TP encapsulation.";
    reference
      "RFC 2661: Layer Two Tunneling Protocol 'L2TP'";
  }

  identity pptp {
    base ift:tunnel;
    description
      "PPTP encapsulation.";
    reference
      "RFC 2637: Point-to-Point Tunneling Protocol (PPTP)";
  }

  identity l2f {
    base ift:tunnel;
    description
      "L2F encapsulation.";
    reference
      "RFC 2341: Cisco Layer Two Forwarding (Protocol) 'L2F'";
  }

  identity udp {
    base ift:tunnel;
    description
      "UDP encapsulation.";
    reference
      "RFC 1234: Tunneling IPX Traffic through IP Networks,
       RFC 8085: UDP Usage Guidelines, Section 3.1.11";
  }

  identity atmp {
    base ift:tunnel;
    description
      "ATMP encapsulation.";
    reference
      "RFC 2107: Ascend Tunnel Management Protocol - ATMP";
  }

  identity msdp {
    base ift:tunnel;
    description
      "MSDP encapsulation.";
    reference
      "RFC 3618: Multicast Source Discovery Protocol (MSDP)";
  }

  identity sixtofour {
    base ift:tunnel;
    description
      "6to4 encapsulation.";
    reference
      "RFC 3056: Connection of IPv6 Domains via IPv4 Clouds";
  }

  identity sixoverfour {
    base ift:tunnel;
    description
      "6over4 encapsulation.";
    reference
      "RFC 2529: Transmission of IPv6 over IPv4 Domains without
                 Explicit Tunnels";
  }

  identity isatap {
    base ift:tunnel;
    description
      "ISATAP encapsulation.";
    reference
      "RFC 5214:  Intra-Site Automatic Tunnel Addressing Protocol
                 (ISATAP)";
  }

  identity teredo {
    base ift:tunnel;
    description
      "Teredo encapsulation.";
    reference
      "RFC 4380: Teredo: Tunneling IPv6 over UDP through
                 Network Address Translations (NATs)";
  }

  identity iphttps {
    base ift:tunnel;
    description
      "IP over HTTPS (IP-HTTPS) Tunneling Protocol.";
    reference
      "Microsoft Corporation, IP over HTTPS (IP-HTTPS) Tunneling
       Protocol Specification,
       https://msdn.microsoft.com/en-us/library/dd358571.aspx";
  }

  identity softwiremesh {
    base ift:tunnel;
    description
      "softwire mesh tunnel.";
    reference
      "RFC 5565: Softwire Mesh Framework";
  }

  identity dslite {
    base ift:tunnel;
    description
      "DS-Lite tunnel.";
    reference
      "RFC 6333: Dual-Stack Lite Broadband Deployments Following
                 IPv4 Exhaustion";
  }

  identity aplusp {
    base ift:tunnel;
    description
      "A+P encapsulation.";
    reference
      "RFC 6346: The Address plus Port (A+P) Approach to the IPv4
                 Address Shortage";
  }
}

Security Considerations
The YANG module specified in this document defines a schema for data that is designed to be accessed via network management protocols such as NETCONF [RFC6241] or RESTCONF [RFC8040]. The lowest NETCONF layer is the secure transport layer, and the mandatory-to-implement secure transport is Secure Shell (SSH) [RFC6242]. The lowest RESTCONF layer is HTTPS, and the mandatory-to-implement secure transport is TLS [RFC8446].
The Network Configuration Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a preconfigured subset of all available NETCONF or RESTCONF protocol operations and content.
The module defined in this document defines YANG identities for the iana-tunnel-types registry. These identities are intended to be referenced by other YANG modules, and by themselves do not expose any nodes which are writable, contain read-only state, or RPCs. As such, there are no additional security issues to be considered relating to the module defined in this document.
IANA Considerations
YANG Module
IANA has registered the following URI in the "ns" subregistry within the "IETF XML Registry" [RFC3688]:
URI:
urn:ietf:params:xml:ns:yang:iana-tunnel-type
Registrant Contact:
IANA
XML:
N/A; the requested URI is an XML namespace.
IANA registered the following YANG module in the "YANG Module Names" subregistry [RFC7950] within the "YANG Parameters" registry.
Name:
iana-tunnel-type
Namespace:
urn:ietf:params:xml:ns:yang:iana-tunnel-type
Prefix:
iana-tunnel-type
Reference:
RFC 8675
This document defines the initial version of the IANA-maintained iana-tunnel-type YANG module. IANA has added this note to the registry:
- Tunnel type values must not be directly added to the iana-tunnel-type YANG module. They must instead be added to the "tunnelType" subregistry (under the "ifType definitions" registry) at [IANA registry smi-numbers].
When a tunnel type is added to the "tunnelType" subregistry, a new "identity" statement must be added to the iana-tunnel-type YANG module. The name of the "identity" is the lower-case of the corresponding enumeration in the IANAifType-MIB (i.e., IANAtunnelType). The "identity" statement should have the following sub-statements defined:
"base":
Contains 'ift:tunnel'.
"description":
Replicates the description from the registry.
"reference":
Replicates the reference from the registry and adds the title of the document.
Unassigned or reserved values are not present in the module.
When the iana-tunnel-type YANG module is updated, a new "revision" statement must be added in front of the existing revision statements.
IANA has added the following note to "tunnelType" subregistry:
- When this registry is modified, the YANG module iana-tunnel-type must be updated as defined in RFC 8675.
Updates to the IANA tunnelType Table
IANA has updated the following entries in the tunnelType registry under the SMI Numbers registry [TUNNELTYPE-IANA-REGISTRY].
OLD:
Decimal | Name | Description | References
2 | direct | no intermediate header | [RFC4087]
3 | gre | GRE encapsulation | [RFC4087]
4 | minimal | Minimal encapsulation | [RFC4087]
5 | l2tp | L2TP encapsulation | [RFC4087]
6 | pptp | PPTP encapsulation | [RFC4087]
7 | l2f | L2F encapsulation | [RFC4087]
8 | udp | UDP encapsulation | [RFC4087]
9 | atmp | ATMP encapsulation | [RFC4087]
10 | msdp | MSDP encapsulation | [RFC4087]
11 | sixToFour | 6to4 encapsulation | [RFC4087]
12 | sixOverFour | 6over4 encapsulation | [RFC4087]
13 | isatap | ISATAP encapsulation | [RFC4087]
14 | teredo | Teredo encapsulation | [RFC4087]
16 | softwireMesh | softwire mesh tunnel | [RFC7856]
17 | dsLite | DS-Lite tunnel | [RFC7870]
NEW:
Decimal | Name | Description | References
2 | direct | no intermediate header | [RFC2003] [RFC4213]
3 | gre | GRE encapsulation | [RFC1701] [RFC1702] [RFC7676]
4 | minimal | Minimal encapsulation | [RFC2004]
5 | l2tp | L2TP encapsulation | [RFC2661]
6 | pptp | PPTP encapsulation | [RFC2637]
7 | l2f | L2F encapsulation | [RFC2341]
8 | udp | UDP encapsulation | [RFC8085]
9 | atmp | ATMP encapsulation | [RFC2107]
10 | msdp | MSDP encapsulation | [RFC3618]
11 | sixToFour | 6to4 encapsulation | [RFC3056]
12 | sixOverFour | 6over4 encapsulation | [RFC2529]
13 | isatap | ISATAP encapsulation | [RFC5214]
14 | teredo | Teredo encapsulation | [RFC4380]
16 | softwireMesh | softwire mesh tunnel | [RFC5565]
17 | dsLite | DS-Lite tunnel | [RFC6333]
References
Normative References
[RFC3688]

The IETF XML Registry
M. Mealling
January 2004
BCP 81
RFC 3688
DOI 10.17487/RFC3688
[RFC6241]

Network Configuration Protocol (NETCONF)
R. Enns, Ed.
M. Bjorklund, Ed.
J. Schoenwaelder, Ed.
A. Bierman, Ed.
June 2011
RFC 6241
DOI 10.17487/RFC6241
[RFC6242]

Using the NETCONF Protocol over Secure Shell (SSH)
M. Wasserman
June 2011
RFC 6242
DOI 10.17487/RFC6242
[RFC6991]

Common YANG Data Types
J. Schoenwaelder, Ed.
July 2013
RFC 6991
DOI 10.17487/RFC6991
[RFC7224]

IANA Interface Type YANG Module
M. Bjorklund
May 2014
RFC 7224
DOI 10.17487/RFC7224
[RFC7950]

The YANG 1.1 Data Modeling Language
M. Bjorklund, Ed.
August 2016
RFC 7950
DOI 10.17487/RFC7950
[RFC8040]

RESTCONF Protocol
A. Bierman
M. Bjorklund
K. Watsen
January 2017
RFC 8040
DOI 10.17487/RFC8040
[RFC8341]

Network Configuration Access Control Model
A. Bierman
M. Bjorklund
March 2018
STD 91
RFC 8341
DOI 10.17487/RFC8341
[RFC8342]

Network Management Datastore Architecture (NMDA)
M. Bjorklund
J. Schoenwaelder
P. Shafer
K. Watsen
R. Wilton
March 2018
RFC 8342
DOI 10.17487/RFC8342
[RFC8446]

The Transport Layer Security (TLS) Protocol Version 1.3
E. Rescorla
August 2018
RFC 8446
DOI 10.17487/RFC8446
[TUNNELTYPE-IANA-REGISTRY]

Structure of Management Information (SMI) Numbers (MIB Module Registrations)
IANA
Informative References
[I-D.thaler-iftype-reg]

Guidelines and Registration Procedures for Interface Types and Tunnel Types
Dave Thaler
Dan Romascanu
2 November 2019
Internet-Draft draft-thaler-iftype-reg-06
Work in Progress
[RFC1701]

Generic Routing Encapsulation (GRE)
S. Hanks
T. Li
D. Farinacci
P. Traina
October 1994
RFC 1701
DOI 10.17487/RFC1701
[RFC1702]

Generic Routing Encapsulation over IPv4 networks
S. Hanks
T. Li
D. Farinacci
P. Traina
October 1994
RFC 1702
DOI 10.17487/RFC1702
[RFC2003]

IP Encapsulation within IP
C. Perkins
October 1996
RFC 2003
DOI 10.17487/RFC2003
[RFC2004]

Minimal Encapsulation within IP
C. Perkins
October 1996
RFC 2004
DOI 10.17487/RFC2004
[RFC2107]

Ascend Tunnel Management Protocol - ATMP
K. Hamzeh
February 1997
RFC 2107
DOI 10.17487/RFC2107
[RFC2341]

Cisco Layer Two Forwarding (Protocol) "L2F"
A. Valencia
M. Littlewood
T. Kolar
May 1998
RFC 2341
DOI 10.17487/RFC2341
[RFC2529]

Transmission of IPv6 over IPv4 Domains without Explicit Tunnels
B. Carpenter
C. Jung
March 1999
RFC 2529
DOI 10.17487/RFC2529
[RFC2637]

Point-to-Point Tunneling Protocol (PPTP)
K. Hamzeh
G. Pall
W. Verthein
J. Taarud
W. Little
G. Zorn
July 1999
RFC 2637
DOI 10.17487/RFC2637
[RFC2661]

Layer Two Tunneling Protocol "L2TP"
W. Townsley
A. Valencia
A. Rubens
G. Pall
G. Zorn
B. Palter
August 1999
RFC 2661
DOI 10.17487/RFC2661
[RFC3056]

Connection of IPv6 Domains via IPv4 Clouds
B. Carpenter
K. Moore
February 2001
RFC 3056
DOI 10.17487/RFC3056
[RFC3618]

Multicast Source Discovery Protocol (MSDP)
B. Fenner, Ed.
D. Meyer, Ed.
October 2003
RFC 3618
DOI 10.17487/RFC3618
[RFC4087]

IP Tunnel MIB
D. Thaler
June 2005
RFC 4087
DOI 10.17487/RFC4087
[RFC4213]

Basic Transition Mechanisms for IPv6 Hosts and Routers
E. Nordmark
R. Gilligan
October 2005
RFC 4213
DOI 10.17487/RFC4213
[RFC4380]

Teredo: Tunneling IPv6 over UDP through Network Address Translations (NATs)
C. Huitema
February 2006
RFC 4380
DOI 10.17487/RFC4380
[RFC5214]

Intra-Site Automatic Tunnel Addressing Protocol (ISATAP)
F. Templin
T. Gleeson
D. Thaler
March 2008
RFC 5214
DOI 10.17487/RFC5214
[RFC5565]

Softwire Mesh Framework
J. Wu
Y. Cui
C. Metz
E. Rosen
June 2009
RFC 5565
DOI 10.17487/RFC5565
[RFC6333]

Dual-Stack Lite Broadband Deployments Following IPv4 Exhaustion
A. Durand
R. Droms
J. Woodyatt
Y. Lee
August 2011
RFC 6333
DOI 10.17487/RFC6333
[RFC6346]

The Address plus Port (A+P) Approach to the IPv4 Address Shortage
R. Bush, Ed.
August 2011
RFC 6346
DOI 10.17487/RFC6346
[RFC7676]

IPv6 Support for Generic Routing Encapsulation (GRE)
C. Pignataro
R. Bonica
S. Krishnan
October 2015
RFC 7676
DOI 10.17487/RFC7676
[RFC7856]

Softwire Mesh Management Information Base (MIB)
Y. Cui
J. Dong
P. Wu
M. Xu
A. Yla-Jaaski
May 2016
RFC 7856
DOI 10.17487/RFC7856
[RFC7870]

Dual-Stack Lite (DS-Lite) Management Information Base (MIB) for Address Family Transition Routers (AFTRs)
Y. Fu
S. Jiang
J. Dong
Y. Chen
June 2016
RFC 7870
DOI 10.17487/RFC7870
[RFC8085]

UDP Usage Guidelines
L. Eggert
G. Fairhurst
G. Shepherd
March 2017
BCP 145
RFC 8085
DOI 10.17487/RFC8085
[RFC8340]

YANG Tree Diagrams
M. Bjorklund
L. Berger, Ed.
March 2018
BCP 215
RFC 8340
DOI 10.17487/RFC8340
[RFC8343]

A YANG Data Model for Interface Management
M. Bjorklund
March 2018
RFC 8343
DOI 10.17487/RFC8343
[RFC8676]

YANG Modules for IPv4-in-IPv6 Address plus Port (A+P) Softwires
Ian Farrer, Ed.
Mohamed Boucadair, Ed.
November 2019
RFC 8676
DOI 10.17487/RFC8676
Example Usage
The following example illustrates how the Interface YANG module can be augmented with tunnel-specific parameters. In this example, the module is augmented with a 'remote-endpoint' for the tunnel. A tree structure is provided below:

module: example-iftunnel-extension
  augment /if:interfaces/if:interface:
    +--rw remote-endpoint?   inet:ipv6-address

The 'example-iftunnel-extension' module imports the modules defined in [RFC6991] and [RFC8343] in addition to the "iana-tunnel-type" module defined in this document.
module example-iftunnel-extension {
  yang-version 1.1;

  namespace "urn:ietf:params:xml:ns:yang:example-iftunnel-extension";
  prefix example;

  import ietf-inet-types {
    prefix inet;
    reference
      "RFC 6991: Common YANG Data Types, Section 4";
  }

  import ietf-interfaces {
    prefix if;
    reference
      "RFC 8343: A YANG Data Model for Interface Management";
  }

  import iana-tunnel-type  {
    prefix iana-tunnel-type;
    reference
      "RFC 8675:  A Tunnel Extension to the Interface Management
                  YANG Module";
  }

  organization "IETF Softwire Working Group";

  contact

    "WG Web:   <https://datatracker.ietf.org/wg/softwire/>
     WG List:  <mailto:softwire@ietf.org>

     Author:  Mohamed Boucadair
              <mailto:mohamed.boucadair@orange.com>";

   description
      "This is an example YANG module to extend the Interface YANG
       module with tunnel-specific parameters.

      Copyright (c) 2019 IETF Trust and the persons identified as
      authors of the code.  All rights reserved.

      Redistribution and use in source and binary forms, with or
      without modification, is permitted pursuant to, and subject
      to the license terms contained in, the Simplified BSD License
      set forth in Section 4.c of the IETF Trust's Legal Provisions
      Relating to IETF Documents
      (http://trustee.ietf.org/license-info).

      This version of this YANG module is part of RFC 8675; see
      the RFC itself for full legal notices.";

  revision 2019-10-21 {
    description
      "Initial revision.";
    reference
      "RFC 8675:  Tunnel Interface Types YANG Module";
  }

  augment "/if:interfaces/if:interface" {
    when "derived-from(if:type, 'iana-tunnel-type:gre')";
    description
      "Augments Interface module with specific tunnel parameters.";

    leaf remote-endpoint {
      type inet:ipv6-address;
      description
        "IPv6 address of the remote GRE endpoint.";
    }
  }
}

Acknowledgements
Special thanks to Tom Petch and Martin Bjorklund for the detailed review and suggestions.
Thanks to Andy Bierman for the Yangdoctors review.
Thanks to Dale Worley, David Black, and Yaron Sheffer for the review.
Authors' Addresses
Mohamed Boucadair
Orange
Rennes
35000
France
mohamed.boucadair@orange.com
Ian Farrer
Deutsche Telekom AG
CTO-ATI, Landgrabenweg 151
Bonn
NRW
53227
Germany
ian.farrer@telekom.de
Rajiv Asati
Cisco Systems, Inc.
7025 Kit Creek Rd.
RTP
NC
27709
United States of America
Rajiva@cisco.com